

service: appslibrary

provider:
  name: aws
  runtime: nodejs6.10
  stage: dev
  region: ap-northeast-1
  stackTags: 
      type: APPSLIBRARY
      
  # 環境変数
  environment:
    DYNAMODB_APPS_MASTER: aplbAppsMaster
    DYNAMODB_CATEGORY_MASTER: aplbCategoryMaster
    S3_FILE_BUCKET: aplb-filebucket
    
  
  # ロール設定(DynamoDB, S3)
  iamRoleStatements:
    - Effect: Allow
      Action:
        - dynamodb:*
      Resource: arn:aws:dynamodb:*:*:table/*

    - Effect: Allow
      Action:
        - s3:*
      Resource: arn:aws:s3:::aplb-filebucket/*

    # - Effect: Allow
    #   Action:
    #     - lambda:InvokeFunction
    #   Resource: '*'

# 関数定義
functions:
  createPlist:
    handler: js/plist.post
    timeout: 30 
    description: plistファイルを作成し、S3に保存する
    events:
      - http:
          path: plist
          method: post
          cors: true

  getApps:
    handler: js/app.get
    timeout: 30 
    description: アイテム一覧を取得する
    events:
      - http:
          path: item
          method: get
          cors: true

  getSpecificApp:
    handler: js/app.getSpecificApp
    timeout: 30 
    description: 指定したIDのアプリ情報を取得する
    events:
      - http:
          path: item/{id}
          method: get
          cors: true
  
  uploadApp:
    handler: js/app.post
    timeout: 30 
    description: 新規アイテムをアップロードする
    events:
      - http:
          path: item
          method: post
          cors: true

  modifyApp:
    handler: js/app.put
    timeout: 30 
    description: アイテムを更新する
    events:
      - http:
          path: item
          method: put
          cors: true

  deleteApp:
    handler: js/app.delete
    timeout: 30 
    description: アイテムを削除する
    events:
      - http:
          path: item
          method: delete
          cors: true

  getCategory:
    handler: js/category.get
    timeout: 30 
    description: カテゴリー一覧取得する
    events:
      - http:
          path: category
          method: get
          cors: true

  postCategory:
    handler: js/category.post
    timeout: 30 
    description: カテゴリーを新規作成する
    events:
      - http:
          path: category
          method: post
          cors: true

  putCategory:
    handler: js/category.put
    timeout: 30 
    description: カテゴリー名・シーケンス番号を変更する
    events:
      - http:
          path: category
          method: put
          cors: true

  deleteCategory:
    handler: js/category.delete
    timeout: 30 
    description: カテゴリーを削除する
    events:
      - http:
          path: category
          method: delete
          cors: true


# テーブル、S3定義
resources:
  Resources:
    
    # アプリ情報テーブル
    aplbAppsMaster:
      Type: 'AWS::DynamoDB::Table'
      DeletionPolicy: Retain
      Properties:
        AttributeDefinitions:
          -
            AttributeName: id
            AttributeType: S
        KeySchema:
          -
            AttributeName: id
            KeyType: HASH
        ProvisionedThroughput:
          ReadCapacityUnits: 3
          WriteCapacityUnits: 3
        TableName: aplbAppsMaster
    
    # カテゴリテーブル
    aplbCategoryMaster:
        Type: 'AWS::DynamoDB::Table'
        DeletionPolicy: Retain
        Properties:
          AttributeDefinitions:
            -
              AttributeName: id
              AttributeType: S
          KeySchema:
            -
              AttributeName: id
              KeyType: HASH
          ProvisionedThroughput:
            ReadCapacityUnits: 2
            WriteCapacityUnits: 3
          TableName: aplbCategoryMaster

    
    # ファイルストレージ(ipa,plist,image)
    aplbfilebucket:
      Type: AWS::S3::Bucket
      DeletionPolicy: Retain
      Properties:
        BucketName: aplb-filebucket
